{ ************************************************************************ }
{ Ancestral Forms 1.1 Demonstration                                        }
{ (C) Sam Liddicott 1996                                                   }
{ ------------------------------------------------------------------------ }
{ This is a parent form.  The only special requirements are:               }
{   * Uses ...,RootForm......;                                             }
{   * TAncestorForm=class(TRootForm)                                       }
{ ************************************************************************ }
unit Parent;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, rootform, Buttons, TabNotBk;

type
  TAncestorForm = class(TRootForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    Label2: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    Procedure Loaded; override;
  public
  end;

var
  AncestorForm: TAncestorForm;

implementation

{$R *.DFM}

{ Close the form (and application if we are the main form) }
{ This event handler is not overridden in the child form, but could be }
procedure TAncestorForm.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

{ Button1Click is overridden in the child form }
procedure TAncestorForm.Button1Click(Sender: TObject);
begin
  Panel1.Caption:='Ancestral Button1 Click';
end;

{ This is to demonstrate the repeated calls the the forms own .loaded }
{ csLoading is always maintained in component state until after the }
{ last set of resources has loaded. }
{ I.E. After you call inherited .loaded, IF ClassLevel=0, then csLoading }
{ is no longer in ComponentState }
Procedure TAncestorForm.Loaded;
begin
  writeln(Classname,': ',CurrentClass.classname,' ',ClassLevel);
  Inherited Loaded;
end;

end.
